#!/bin/tclsh
#glftpd.conf:
#site_cmd ONEL		EXEC	/bin/onel.tcl
#
set sonelf /ftp-data/misc/oneliners
set max 7

puts -nonewline ""; 	#doesn't work without this line

catch {exec /bin/echo - $err >> /tmp/err}

proc add {} {global sonelf max env argv
  if {![file writable $sonelf]||![file exists $sonelf]} {
    puts "ERROR: file error";exit 0
  }
  set of [open $sonelf r]
  set inbuf [split [read -nonewline $of] \n]
  close $of
  set inbuf "\{\{$env(USER)\} [clock seconds] \{$argv\}\} $inbuf"
  set inbuf [lrange $inbuf 0 [expr $max - 1]]
  set of [open $sonelf w]
  foreach line $inbuf {if {$line != ""} {puts $of $line}}
  close $of
  puts "Your oneliner has been added."
}

proc view {} {global sonelf 
  if {[catch {set of [open /ftp-data/text/onel.head]} err] == 0} {
    puts [read -nonewline $of] ; close $of
  }
  set of [open $sonelf]
  set inbuf [split [read -nonewline $of] \n]
  close $of
  foreach line $inbuf {
    puts "\[[format %-10s [lindex $line 0]]\] [lindex $line 2]"
  }
  if {[catch {set of [open /ftp-data/text/onel.foot]}] == 0} {
    puts [read -nonewline $of] ; close $of
  }
}

if {$argv == ""} {view} else {add}

